/**
 */
package net.astah.stpa.stamp.notation.impl;

import java.util.Collection;

import net.astah.dd.dc.Point;

import net.astah.dd.di.DiagramElement;
import net.astah.dd.di.Edge;
import net.astah.dd.di.Style;
import net.astah.notation.AnchorConstraint;

import net.astah.notation.LineConstraint;
import net.astah.notation.impl.EdgeImpl;

import net.astah.stpa.stamp.Element;

import net.astah.stpa.stamp.notation.STAMPDiagramElement;
import net.astah.stpa.stamp.notation.STAMPEdge;
import net.astah.stpa.stamp.notation.STAMPNotationPackage;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.uml2.common.util.CacheAdapter;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>STAMP Edge</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link net.astah.stpa.stamp.notation.impl.STAMPEdgeImpl#getSTAMPModelElements <em>STAMP Model Element</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.notation.impl.STAMPEdgeImpl#getSTAMPOwningElement <em>STAMP Owning Element</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.notation.impl.STAMPEdgeImpl#getSTAMPOwnedElements <em>STAMP Owned Element</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.notation.impl.STAMPEdgeImpl#getSTAMPTargetEdges <em>STAMP Target Edge</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.notation.impl.STAMPEdgeImpl#getSTAMPSourceEdges <em>STAMP Source Edge</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.notation.impl.STAMPEdgeImpl#getSTAMPSource <em>STAMP Source</em>}</li>
 *   <li>{@link net.astah.stpa.stamp.notation.impl.STAMPEdgeImpl#getSTAMPTarget <em>STAMP Target</em>}</li>
 * </ul>
 *
 * @generated
 */
public class STAMPEdgeImpl extends EdgeImpl implements STAMPEdge {
    /**
     * The cached value of the '{@link #getSTAMPModelElements() <em>STAMP Model Element</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSTAMPModelElements()
     * @generated
     * @ordered
     */
    protected EList<Element> stampModelElements;

    /**
     * The cached value of the '{@link #getSTAMPOwnedElements() <em>STAMP Owned Element</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSTAMPOwnedElements()
     * @generated
     * @ordered
     */
    protected EList<STAMPDiagramElement> stampOwnedElements;

    /**
     * The cached value of the '{@link #getSTAMPTargetEdges() <em>STAMP Target Edge</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSTAMPTargetEdges()
     * @generated
     * @ordered
     */
    protected EList<STAMPEdge> stampTargetEdges;

    /**
     * The cached value of the '{@link #getSTAMPSourceEdges() <em>STAMP Source Edge</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSTAMPSourceEdges()
     * @generated
     * @ordered
     */
    protected EList<STAMPEdge> stampSourceEdges;

    /**
     * The cached value of the '{@link #getSTAMPSource() <em>STAMP Source</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSTAMPSource()
     * @generated
     * @ordered
     */
    protected STAMPDiagramElement stampSource;

    /**
     * The cached value of the '{@link #getSTAMPTarget() <em>STAMP Target</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSTAMPTarget()
     * @generated
     * @ordered
     */
    protected STAMPDiagramElement stampTarget;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected STAMPEdgeImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return STAMPNotationPackage.Literals.STAMP_EDGE;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<Element> getSTAMPModelElements() {
        if (stampModelElements == null) {
            stampModelElements = new EObjectResolvingEList<Element>(Element.class, this, STAMPNotationPackage.STAMP_EDGE__STAMP_MODEL_ELEMENT);
        }
        return stampModelElements;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetSTAMPModelElements() {
        return stampModelElements != null && !stampModelElements.isEmpty();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPDiagramElement getSTAMPOwningElement() {
        if (eContainerFeatureID() != STAMPNotationPackage.STAMP_EDGE__STAMP_OWNING_ELEMENT) return null;
        return (STAMPDiagramElement)eInternalContainer();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetSTAMPOwningElement(STAMPDiagramElement newSTAMPOwningElement, NotificationChain msgs) {
        msgs = eBasicSetContainer((InternalEObject)newSTAMPOwningElement, STAMPNotationPackage.STAMP_EDGE__STAMP_OWNING_ELEMENT, msgs);
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setSTAMPOwningElement(STAMPDiagramElement newSTAMPOwningElement) {
        if (newSTAMPOwningElement != eInternalContainer() || (eContainerFeatureID() != STAMPNotationPackage.STAMP_EDGE__STAMP_OWNING_ELEMENT && newSTAMPOwningElement != null)) {
            if (EcoreUtil.isAncestor(this, newSTAMPOwningElement))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newSTAMPOwningElement != null)
                msgs = ((InternalEObject)newSTAMPOwningElement).eInverseAdd(this, STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT, STAMPDiagramElement.class, msgs);
            msgs = basicSetSTAMPOwningElement(newSTAMPOwningElement, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPNotationPackage.STAMP_EDGE__STAMP_OWNING_ELEMENT, newSTAMPOwningElement, newSTAMPOwningElement));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetSTAMPOwningElement() {
        return getSTAMPOwningElement() != null;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<STAMPDiagramElement> getSTAMPOwnedElements() {
        if (stampOwnedElements == null) {
            stampOwnedElements = new EObjectContainmentWithInverseEList<STAMPDiagramElement>(STAMPDiagramElement.class, this, STAMPNotationPackage.STAMP_EDGE__STAMP_OWNED_ELEMENT, STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_OWNING_ELEMENT);
        }
        return stampOwnedElements;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPDiagramElement createSTAMPOwnedElement(EClass eClass) {
        STAMPDiagramElement newSTAMPOwnedElement = (STAMPDiagramElement) create(eClass);
        getSTAMPOwnedElements().add(newSTAMPOwnedElement);
        return newSTAMPOwnedElement;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetSTAMPOwnedElements() {
        return stampOwnedElements != null && !stampOwnedElements.isEmpty();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<STAMPEdge> getSTAMPTargetEdges() {
        if (stampTargetEdges == null) {
            stampTargetEdges = new EObjectWithInverseResolvingEList<STAMPEdge>(STAMPEdge.class, this, STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET_EDGE, STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET);
        }
        return stampTargetEdges;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetSTAMPTargetEdges() {
        return stampTargetEdges != null && !stampTargetEdges.isEmpty();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<STAMPEdge> getSTAMPSourceEdges() {
        if (stampSourceEdges == null) {
            stampSourceEdges = new EObjectWithInverseResolvingEList<STAMPEdge>(STAMPEdge.class, this, STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE_EDGE, STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE);
        }
        return stampSourceEdges;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetSTAMPSourceEdges() {
        return stampSourceEdges != null && !stampSourceEdges.isEmpty();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPDiagramElement getSTAMPSource() {
        return stampSource;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetSTAMPSource(STAMPDiagramElement newSTAMPSource, NotificationChain msgs) {
        STAMPDiagramElement oldSTAMPSource = stampSource;
        stampSource = newSTAMPSource;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE, oldSTAMPSource, newSTAMPSource);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setSTAMPSource(STAMPDiagramElement newSTAMPSource) {
        if (newSTAMPSource != stampSource) {
            NotificationChain msgs = null;
            if (stampSource != null)
                msgs = ((InternalEObject)stampSource).eInverseRemove(this, STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_SOURCE_EDGE, STAMPDiagramElement.class, msgs);
            if (newSTAMPSource != null)
                msgs = ((InternalEObject)newSTAMPSource).eInverseAdd(this, STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_SOURCE_EDGE, STAMPDiagramElement.class, msgs);
            msgs = basicSetSTAMPSource(newSTAMPSource, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE, newSTAMPSource, newSTAMPSource));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetSTAMPSource() {
        return stampSource != null;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public STAMPDiagramElement getSTAMPTarget() {
        return stampTarget;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetSTAMPTarget(STAMPDiagramElement newSTAMPTarget, NotificationChain msgs) {
        STAMPDiagramElement oldSTAMPTarget = stampTarget;
        stampTarget = newSTAMPTarget;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET, oldSTAMPTarget, newSTAMPTarget);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setSTAMPTarget(STAMPDiagramElement newSTAMPTarget) {
        if (newSTAMPTarget != stampTarget) {
            NotificationChain msgs = null;
            if (stampTarget != null)
                msgs = ((InternalEObject)stampTarget).eInverseRemove(this, STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_TARGET_EDGE, STAMPDiagramElement.class, msgs);
            if (newSTAMPTarget != null)
                msgs = ((InternalEObject)newSTAMPTarget).eInverseAdd(this, STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_TARGET_EDGE, STAMPDiagramElement.class, msgs);
            msgs = basicSetSTAMPTarget(newSTAMPTarget, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET, newSTAMPTarget, newSTAMPTarget));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetSTAMPTarget() {
        return stampTarget != null;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case STAMPNotationPackage.STAMP_EDGE__EANNOTATIONS:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getEAnnotations()).basicAdd(otherEnd, msgs);
            case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNING_ELEMENT:
                if (eInternalContainer() != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return basicSetSTAMPOwningElement((STAMPDiagramElement)otherEnd, msgs);
            case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNED_ELEMENT:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getSTAMPOwnedElements()).basicAdd(otherEnd, msgs);
            case STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET_EDGE:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getSTAMPTargetEdges()).basicAdd(otherEnd, msgs);
            case STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE_EDGE:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getSTAMPSourceEdges()).basicAdd(otherEnd, msgs);
            case STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE:
                if (stampSource != null)
                    msgs = ((InternalEObject)stampSource).eInverseRemove(this, STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_SOURCE_EDGE, STAMPDiagramElement.class, msgs);
                return basicSetSTAMPSource((STAMPDiagramElement)otherEnd, msgs);
            case STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET:
                if (stampTarget != null)
                    msgs = ((InternalEObject)stampTarget).eInverseRemove(this, STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_TARGET_EDGE, STAMPDiagramElement.class, msgs);
                return basicSetSTAMPTarget((STAMPDiagramElement)otherEnd, msgs);
        }
        return eDynamicInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case STAMPNotationPackage.STAMP_EDGE__EANNOTATIONS:
                return ((InternalEList<?>)getEAnnotations()).basicRemove(otherEnd, msgs);
            case STAMPNotationPackage.STAMP_EDGE__LOCAL_STYLE:
                return basicSetLocalStyle(null, msgs);
            case STAMPNotationPackage.STAMP_EDGE__WAYPOINT:
                return ((InternalEList<?>)getWaypoints()).basicRemove(otherEnd, msgs);
            case STAMPNotationPackage.STAMP_EDGE__SOURCE_ANCHOR:
                return basicSetSourceAnchor(null, msgs);
            case STAMPNotationPackage.STAMP_EDGE__TARGET_ANCHOR:
                return basicSetTargetAnchor(null, msgs);
            case STAMPNotationPackage.STAMP_EDGE__LINE:
                return basicSetLine(null, msgs);
            case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNING_ELEMENT:
                return basicSetSTAMPOwningElement(null, msgs);
            case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNED_ELEMENT:
                return ((InternalEList<?>)getSTAMPOwnedElements()).basicRemove(otherEnd, msgs);
            case STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET_EDGE:
                return ((InternalEList<?>)getSTAMPTargetEdges()).basicRemove(otherEnd, msgs);
            case STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE_EDGE:
                return ((InternalEList<?>)getSTAMPSourceEdges()).basicRemove(otherEnd, msgs);
            case STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE:
                return basicSetSTAMPSource(null, msgs);
            case STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET:
                return basicSetSTAMPTarget(null, msgs);
        }
        return eDynamicInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
        switch (eContainerFeatureID()) {
            case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNING_ELEMENT:
                return eInternalContainer().eInverseRemove(this, STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT, STAMPDiagramElement.class, msgs);
        }
        return eDynamicBasicRemoveFromContainer(msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case STAMPNotationPackage.STAMP_EDGE__EANNOTATIONS:
                return getEAnnotations();
            case STAMPNotationPackage.STAMP_EDGE__MODEL_ELEMENT:
                return getModelElements();
            case STAMPNotationPackage.STAMP_EDGE__OWNING_ELEMENT:
                if (resolve) return getOwningElement();
                return basicGetOwningElement();
            case STAMPNotationPackage.STAMP_EDGE__OWNED_ELEMENT:
                return getOwnedElements();
            case STAMPNotationPackage.STAMP_EDGE__TARGET_EDGE:
                return getTargetEdges();
            case STAMPNotationPackage.STAMP_EDGE__SOURCE_EDGE:
                return getSourceEdges();
            case STAMPNotationPackage.STAMP_EDGE__LOCAL_STYLE:
                return getLocalStyle();
            case STAMPNotationPackage.STAMP_EDGE__SHARED_STYLE:
                if (resolve) return getSharedStyle();
                return basicGetSharedStyle();
            case STAMPNotationPackage.STAMP_EDGE__SOURCE:
                if (resolve) return getSource();
                return basicGetSource();
            case STAMPNotationPackage.STAMP_EDGE__WAYPOINT:
                return getWaypoints();
            case STAMPNotationPackage.STAMP_EDGE__TARGET:
                if (resolve) return getTarget();
                return basicGetTarget();
            case STAMPNotationPackage.STAMP_EDGE__REFERENCE_STYLE:
                return getReferenceStyles();
            case STAMPNotationPackage.STAMP_EDGE__SOURCE_ANCHOR:
                return getSourceAnchor();
            case STAMPNotationPackage.STAMP_EDGE__TARGET_ANCHOR:
                return getTargetAnchor();
            case STAMPNotationPackage.STAMP_EDGE__LINE:
                return getLine();
            case STAMPNotationPackage.STAMP_EDGE__STAMP_MODEL_ELEMENT:
                return getSTAMPModelElements();
            case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNING_ELEMENT:
                return getSTAMPOwningElement();
            case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNED_ELEMENT:
                return getSTAMPOwnedElements();
            case STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET_EDGE:
                return getSTAMPTargetEdges();
            case STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE_EDGE:
                return getSTAMPSourceEdges();
            case STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE:
                return getSTAMPSource();
            case STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET:
                return getSTAMPTarget();
        }
        return eDynamicGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case STAMPNotationPackage.STAMP_EDGE__EANNOTATIONS:
                getEAnnotations().clear();
                getEAnnotations().addAll((Collection<? extends EAnnotation>)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__MODEL_ELEMENT:
                getModelElements().clear();
                getModelElements().addAll((Collection<? extends EObject>)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__OWNING_ELEMENT:
                setOwningElement((DiagramElement)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__OWNED_ELEMENT:
                getOwnedElements().clear();
                getOwnedElements().addAll((Collection<? extends DiagramElement>)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__TARGET_EDGE:
                getTargetEdges().clear();
                getTargetEdges().addAll((Collection<? extends Edge>)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__SOURCE_EDGE:
                getSourceEdges().clear();
                getSourceEdges().addAll((Collection<? extends Edge>)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__LOCAL_STYLE:
                setLocalStyle((Style)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__SHARED_STYLE:
                setSharedStyle((Style)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__SOURCE:
                setSource((DiagramElement)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__WAYPOINT:
                getWaypoints().clear();
                getWaypoints().addAll((Collection<? extends Point>)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__TARGET:
                setTarget((DiagramElement)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__REFERENCE_STYLE:
                getReferenceStyles().clear();
                getReferenceStyles().addAll((Collection<? extends Style>)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__SOURCE_ANCHOR:
                setSourceAnchor((AnchorConstraint)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__TARGET_ANCHOR:
                setTargetAnchor((AnchorConstraint)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__LINE:
                setLine((LineConstraint)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_MODEL_ELEMENT:
                getSTAMPModelElements().clear();
                getSTAMPModelElements().addAll((Collection<? extends Element>)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNING_ELEMENT:
                setSTAMPOwningElement((STAMPDiagramElement)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNED_ELEMENT:
                getSTAMPOwnedElements().clear();
                getSTAMPOwnedElements().addAll((Collection<? extends STAMPDiagramElement>)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET_EDGE:
                getSTAMPTargetEdges().clear();
                getSTAMPTargetEdges().addAll((Collection<? extends STAMPEdge>)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE_EDGE:
                getSTAMPSourceEdges().clear();
                getSTAMPSourceEdges().addAll((Collection<? extends STAMPEdge>)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE:
                setSTAMPSource((STAMPDiagramElement)newValue);
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET:
                setSTAMPTarget((STAMPDiagramElement)newValue);
                return;
        }
        eDynamicSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case STAMPNotationPackage.STAMP_EDGE__EANNOTATIONS:
                getEAnnotations().clear();
                return;
            case STAMPNotationPackage.STAMP_EDGE__MODEL_ELEMENT:
                getModelElements().clear();
                return;
            case STAMPNotationPackage.STAMP_EDGE__OWNING_ELEMENT:
                setOwningElement((DiagramElement)null);
                return;
            case STAMPNotationPackage.STAMP_EDGE__OWNED_ELEMENT:
                getOwnedElements().clear();
                return;
            case STAMPNotationPackage.STAMP_EDGE__TARGET_EDGE:
                getTargetEdges().clear();
                return;
            case STAMPNotationPackage.STAMP_EDGE__SOURCE_EDGE:
                getSourceEdges().clear();
                return;
            case STAMPNotationPackage.STAMP_EDGE__LOCAL_STYLE:
                setLocalStyle((Style)null);
                return;
            case STAMPNotationPackage.STAMP_EDGE__SHARED_STYLE:
                setSharedStyle((Style)null);
                return;
            case STAMPNotationPackage.STAMP_EDGE__SOURCE:
                setSource((DiagramElement)null);
                return;
            case STAMPNotationPackage.STAMP_EDGE__WAYPOINT:
                getWaypoints().clear();
                return;
            case STAMPNotationPackage.STAMP_EDGE__TARGET:
                setTarget((DiagramElement)null);
                return;
            case STAMPNotationPackage.STAMP_EDGE__REFERENCE_STYLE:
                getReferenceStyles().clear();
                return;
            case STAMPNotationPackage.STAMP_EDGE__SOURCE_ANCHOR:
                setSourceAnchor((AnchorConstraint)null);
                return;
            case STAMPNotationPackage.STAMP_EDGE__TARGET_ANCHOR:
                setTargetAnchor((AnchorConstraint)null);
                return;
            case STAMPNotationPackage.STAMP_EDGE__LINE:
                setLine((LineConstraint)null);
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_MODEL_ELEMENT:
                getSTAMPModelElements().clear();
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNING_ELEMENT:
                setSTAMPOwningElement((STAMPDiagramElement)null);
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNED_ELEMENT:
                getSTAMPOwnedElements().clear();
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET_EDGE:
                getSTAMPTargetEdges().clear();
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE_EDGE:
                getSTAMPSourceEdges().clear();
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE:
                setSTAMPSource((STAMPDiagramElement)null);
                return;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET:
                setSTAMPTarget((STAMPDiagramElement)null);
                return;
        }
        eDynamicUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case STAMPNotationPackage.STAMP_EDGE__EANNOTATIONS:
                return eAnnotations != null && !eAnnotations.isEmpty();
            case STAMPNotationPackage.STAMP_EDGE__MODEL_ELEMENT:
                return isSetModelElements();
            case STAMPNotationPackage.STAMP_EDGE__OWNING_ELEMENT:
                return isSetOwningElement();
            case STAMPNotationPackage.STAMP_EDGE__OWNED_ELEMENT:
                return isSetOwnedElements();
            case STAMPNotationPackage.STAMP_EDGE__TARGET_EDGE:
                return isSetTargetEdges();
            case STAMPNotationPackage.STAMP_EDGE__SOURCE_EDGE:
                return isSetSourceEdges();
            case STAMPNotationPackage.STAMP_EDGE__LOCAL_STYLE:
                return localStyle != null;
            case STAMPNotationPackage.STAMP_EDGE__SHARED_STYLE:
                return isSetSharedStyle();
            case STAMPNotationPackage.STAMP_EDGE__SOURCE:
                return isSetSource();
            case STAMPNotationPackage.STAMP_EDGE__WAYPOINT:
                return waypoints != null && !waypoints.isEmpty();
            case STAMPNotationPackage.STAMP_EDGE__TARGET:
                return isSetTarget();
            case STAMPNotationPackage.STAMP_EDGE__REFERENCE_STYLE:
                return referenceStyles != null && !referenceStyles.isEmpty();
            case STAMPNotationPackage.STAMP_EDGE__SOURCE_ANCHOR:
                return sourceAnchor != null;
            case STAMPNotationPackage.STAMP_EDGE__TARGET_ANCHOR:
                return targetAnchor != null;
            case STAMPNotationPackage.STAMP_EDGE__LINE:
                return line != null;
            case STAMPNotationPackage.STAMP_EDGE__STAMP_MODEL_ELEMENT:
                return isSetSTAMPModelElements();
            case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNING_ELEMENT:
                return isSetSTAMPOwningElement();
            case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNED_ELEMENT:
                return isSetSTAMPOwnedElements();
            case STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET_EDGE:
                return isSetSTAMPTargetEdges();
            case STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE_EDGE:
                return isSetSTAMPSourceEdges();
            case STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE:
                return isSetSTAMPSource();
            case STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET:
                return isSetSTAMPTarget();
        }
        return eDynamicIsSet(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
        if (baseClass == STAMPDiagramElement.class) {
            switch (derivedFeatureID) {
                case STAMPNotationPackage.STAMP_EDGE__STAMP_MODEL_ELEMENT: return STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_MODEL_ELEMENT;
                case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNING_ELEMENT: return STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_OWNING_ELEMENT;
                case STAMPNotationPackage.STAMP_EDGE__STAMP_OWNED_ELEMENT: return STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT;
                case STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET_EDGE: return STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_TARGET_EDGE;
                case STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE_EDGE: return STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_SOURCE_EDGE;
                default: return -1;
            }
        }
        return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
        if (baseClass == STAMPDiagramElement.class) {
            switch (baseFeatureID) {
                case STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_MODEL_ELEMENT: return STAMPNotationPackage.STAMP_EDGE__STAMP_MODEL_ELEMENT;
                case STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_OWNING_ELEMENT: return STAMPNotationPackage.STAMP_EDGE__STAMP_OWNING_ELEMENT;
                case STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_OWNED_ELEMENT: return STAMPNotationPackage.STAMP_EDGE__STAMP_OWNED_ELEMENT;
                case STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_TARGET_EDGE: return STAMPNotationPackage.STAMP_EDGE__STAMP_TARGET_EDGE;
                case STAMPNotationPackage.STAMP_DIAGRAM_ELEMENT__STAMP_SOURCE_EDGE: return STAMPNotationPackage.STAMP_EDGE__STAMP_SOURCE_EDGE;
                default: return -1;
            }
        }
        return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
    }

    /**
     * Creates a new instance of the specified Ecore class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param eClass The Ecore class of the instance to create.
     * @return The new instance.
     * @generated
     */
    protected EObject create(EClass eClass) {
        return EcoreUtil.create(eClass);
    }

    /**
     * Retrieves the cache adapter for this '<em><b>STAMP Edge</b></em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return The cache adapter for this '<em><b>STAMP Edge</b></em>'.
     * @generated
     */
    protected CacheAdapter getCacheAdapter() {
        return CacheAdapter.getCacheAdapter(this);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public EList<EObject> getModelElements() {
        @SuppressWarnings("unchecked")
        EList<EObject> stampModelElement = (EList<EObject>)((EList<?>)getSTAMPModelElements());
        return stampModelElement;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetModelElements() {
  		return false;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public DiagramElement getOwningElement() {
        return getSTAMPOwningElement();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public DiagramElement basicGetOwningElement() {
        return getSTAMPOwningElement();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setOwningElement(DiagramElement newOwningElement) {
        if (newOwningElement != null && !(newOwningElement instanceof STAMPDiagramElement)) {
            throw new IllegalArgumentException("newOwningElement must be an instance of STAMPDiagramElement");
        }
        setSTAMPOwningElement((STAMPDiagramElement) newOwningElement);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetOwningElement() {
  		return false;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public EList<DiagramElement> getOwnedElements() {
        @SuppressWarnings("unchecked")
        EList<DiagramElement> stampOwnedElement = (EList<DiagramElement>)((EList<?>)getSTAMPOwnedElements());
        return stampOwnedElement;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetOwnedElements() {
  		return false;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public EList<Edge> getTargetEdges() {
        @SuppressWarnings("unchecked")
        EList<Edge> stampTargetEdge = (EList<Edge>)((EList<?>)getSTAMPTargetEdges());
        return stampTargetEdge;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetTargetEdges() {
  		return false;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public EList<Edge> getSourceEdges() {
        @SuppressWarnings("unchecked")
        EList<Edge> stampSourceEdge = (EList<Edge>)((EList<?>)getSTAMPSourceEdges());
        return stampSourceEdge;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetSourceEdges() {
  		return false;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public DiagramElement getSource() {
        return getSTAMPSource();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public DiagramElement basicGetSource() {
        return getSTAMPSource();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setSource(DiagramElement newSource) {
        if (newSource != null && !(newSource instanceof STAMPDiagramElement)) {
            throw new IllegalArgumentException("newSource must be an instance of STAMPDiagramElement");
        }
        setSTAMPSource((STAMPDiagramElement) newSource);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetSource() {
  		return false;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public DiagramElement getTarget() {
        return getSTAMPTarget();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public DiagramElement basicGetTarget() {
        return getSTAMPTarget();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setTarget(DiagramElement newTarget) {
        if (newTarget != null && !(newTarget instanceof STAMPDiagramElement)) {
            throw new IllegalArgumentException("newTarget must be an instance of STAMPDiagramElement");
        }
        setSTAMPTarget((STAMPDiagramElement) newTarget);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSetTarget() {
  		return false;
    }

} //STAMPEdgeImpl
