package net.astah.stpa.stamp.ui.view.proptab;

import static net.astah.stpa.stamp.STAMPPackage.Literals.IDENTIFIED_ELEMENT__DESCRIPTION;
import static net.astah.stpa.stamp.STAMPPackage.Literals.IDENTIFIED_ELEMENT__ID;

import java.awt.Component;

import net.astah.stpa.stamp.IdentifiedElement;
import net.astah.stpa.stamp.ui.Messages;

/**
 * {@link IdentifiedElement} のプロパティのベースタブを実装します。
 */
public class STAMPIdentifiedElementBaseTab extends STAMPModelTab {

    private static final long serialVersionUID = -6240137459934790565L;

    @Override
    protected void initPanelRows() {
        // ID
        final Component idCelleditor = createPropertyCellEditorComponent(IDENTIFIED_ELEMENT__ID);
        addRow(baseItemsPanel, layout, Messages.projectview_base_tab_id_label, idCelleditor);

        // Description
        final String key = Messages.projectview_base_tab_description_label;
        initMultiLineTextArea(key, IDENTIFIED_ELEMENT__DESCRIPTION, 3);
    }

    @Override
    public String getTabName() {
        return Messages.projectview_base_tab_title;
    }

}
