package net.astah.stpa.stamp.ui.view.proptab;

import static net.astah.stpa.stamp.STAMPPackage.Literals.COMPONENT__RESPONSIBILITY;
import static net.astah.stpa.stamp.STAMPPackage.Literals.NAMED_ELEMENT__NAME;

import java.awt.Component;

import net.astah.stpa.stamp.ui.Messages;

/**
 * コンポーネントのプロパティのベースタブを実装します。
 */
public class STAMPComponentBaseTab extends STAMPModelTab {

    private static final long serialVersionUID = -1900792199104836968L;

    @Override
    void initPanelRows() {
        // name
        final Component nameCelleditor = createPropertyCellEditorComponent(NAMED_ELEMENT__NAME);
        addRow(baseItemsPanel, layout, Messages.projectview_base_tab_name_label,
                nameCelleditor);

        // responsibility
        final String key = Messages.projectview_base_tab_responsibility_label;
        initMultiLineTextArea(key, COMPONENT__RESPONSIBILITY, 3);

    }

    @Override
    public String getTabName() {
        return Messages.projectview_base_tab_title;
    }
}
